%if %mdkversion <= 1010
%define build_dkms 1
%else
%define build_dkms 0
%endif
%{?_with_dkms:%define build_dkms 1}
%{?_without_dkms:%define build_dkms 0}

%define	name	ndiswrapper
%define	version	1.0
%define	release	%mkrel 3

Name: 		%{name}
Version: 	%{version}
Release: 	%{release}
License: 	GPL
Group: 		System/Configuration/Hardware
URL:		http://ndiswrapper.sourceforge.net/
Source0: 	http://prdownloads.sourceforge.net/ndiswrapper/%{name}-%{version}.tar.gz
Patch0: 	ndiswrapper-1.0-spaces.patch.bz2
Prereq: 	fileutils hotplug
Requires: 	kernel
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Summary: 	NdisWrapper binary loader utility

%description
Some vendors refuses to release specs or even a binary 
linux-driver for their WLAN cards. This project tries 
to solve this problem by making a kernel module that 
can load Ndis (windows network driver API) drivers. 
We're not trying to implement all of the Ndis API 
but rather implement the functions needed to get 
these unsupported cards working.

%if %build_dkms
%package -n dkms-%{name}
Summary:	DKMS-ready kernel-source for the Intel Pro Wireless 2100 driver
License:	GPL
Group:		Kernel
Requires(pre):	dkms
Requires(post): dkms

%description -n dkms-%{name}
DKMS package for %{name} kernel module.
%endif

%prep
%setup -q
%patch0 -p1 -b .spaces

%build
pushd utils
CFLAGS="$RPM_OPT_FLAGS -DNDISWRAPPER_VERSION=\\\"%{version}\\\""
%ifarch ppc
%make CFLAGS="$CFLAGS" loadndisdriver
%else
%make CFLAGS="$CFLAGS"
%endif 
popd

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -m755 utils/loadndisdriver -D $RPM_BUILD_ROOT/sbin/loadndisdriver
install -m755 utils/ndiswrapper -D $RPM_BUILD_ROOT%{_sbindir}/ndiswrapper
install -m755 utils/ndiswrapper-buginfo -D $RPM_BUILD_ROOT%{_sbindir}/ndiswrapper-buginfo

%if %build_dkms
mkdir -p %{buildroot}/usr/src/%{name}-%{version}-%{release}
cp -a driver/* %{buildroot}/usr/src/%{name}-%{version}-%{release}
install version %{buildroot}/usr/src/%{name}-%{version}-%{release}
perl -pi -e 's/^(.include\s+).*(version)/${1} ${2}/g' %{buildroot}/usr/src/%{name}-%{version}-%{release}/Makefile
cat > %{buildroot}/usr/src/%{name}-%{version}-%{release}/dkms.conf <<EOF

PACKAGE_VERSION="%{version}-%{release}"

# Items below here should not have to change with each driver version
PACKAGE_NAME="%{name}"
MAKE[0]="make KVERS=\${kernelver} -C \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build"
CLEAN="make -C \${kernel_source_dir} SUBDIRS=\${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build clean"

BUILT_MODULE_NAME[0]="\$PACKAGE_NAME"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{name}"
MODULES_CONF_ALIAS_TYPE[0]="eth"

REMAKE_INITRD="no"
AUTOINSTALL=yes

#PATCH[0]="ipw2100-2.4.25-patch"
#PATCH_MATCH[0]="2\.4\.25"
#PATCH[1]="ipw2100-2.6.5-patch"
#PATCH_MATCH[1]="2\.6\.5"
EOF
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%post 
echo -e "please download binary driver at http://ndiswrapper.sourceforge.net/wiki/index.php/List\nuse ndiswrapper -i <inffile.inf> as root to install driver"

%if %build_dkms
%post -n dkms-%{name}
if [ $1 == 1 ]
  then dkms add -m %{name} -v %{version}-%{release} --rpm_safe_upgrade
  dkms build -m %{name} -v %{version}-%{release} --rpm_safe_upgrade
  dkms install -m %{name} -v %{version}-%{release} --rpm_safe_upgrade

fi

%preun -n dkms-%{name}
#if [ $1 == 0 ]
#  then dkms remove -m %{name} -v %{version} --rpm_safe_upgrade --all ||:
#fi
%endif

%files
%defattr(-,root,root) 
%doc AUTHORS README ChangeLog INSTALL
/sbin/loadndisdriver
%{_sbindir}/ndiswrapper
%{_sbindir}/ndiswrapper-buginfo
%{_sysconfdir}/%{name}

%if %build_dkms
%files -n dkms-%{name}
%defattr(-,root,root)
/usr/src/%{name}-%{version}-%{release}
%endif

%changelog
* Wed Mar 30 2005 Olivier Blin <oblin@mandrakesoft.com> 1.0-3mdk
- Patch0: fix driver installation if its path contains spaces

* Mon Feb 14 2005 Buchan Milne <bgmilne@linux-mandrake.com> 1.0-2mdk
- merge dkms subpackage that was created while package was in main cvs
- fix DistroSpecificReleaseTag (will require compat macros for backport)

* Tue Feb  09 2005 Angelo Naselli <anaselli@mandrake.org> 1.0-1mdk
- 1.0
- added DistroSpecificReleaseTag

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.12-1mdk
- 0.12
- fix url to list of cards
- cosmetics

* Sat Nov 06 2004 Guillaume Rousse <guillomovitch@mandrake.org> 0.11-1mdk 
- new version
- fixed build

* Fri Aug 06 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9-1mdk
- 0.9
- cleanups

* Wed Jul 21 2004 Nicolas Planel <nplanel@mandrakesoft.com> 0.8-1mdk
- 0.8.

* Wed May 19 2004 Stew Benedict <sbenedict@mandrakesoft.com> 0.7-5mdk
- try again to drop wlan_radio_averatec_5110hx build on ppc

* Mon May 17 2004 Nicolas Planel <nplanel@mandrakesoft.com> 0.7-4mdk
- add /etc/ndiswrapper directory.
- loadndiswrapper need to be in /sbin path (called from kernel module driver).

* Wed May 12 2004 Stew Benedict <sbenedict@mandrakesoft.com> 0.7-3mdk
- include INSTALL doc with the info on how to setup/install drivers

* Tue May 11 2004 Stew Benedict <sbenedict@mandrakesoft.com> 0.7-2mdk
- drop wlan_radio_averatec_5110hx build on ppc, include the bin otherwise

* Wed Apr 28 2004 Austin Acton <austin@mandrake.org> 0.7-1mdk
- 0.7

* Fri Mar 12 2004 Nicolas Planel <nplanel@mandrakesoft.com> 0.4-1mdk
- bump version to 0.4.

* Tue Dec 16 2003 Nicolas Planel <nplanel@mandrakesoft.com> 0.2-1mdk
- First version for MandrakeSoft.
